<?php
/*
 * Created on 23.10.2007 - 21:45:43
 *
 * +-----------------------------------------+
 * | PHP version 5.2                         |
 * +-----------------------------------------+
 * | Copyright (c) 2007 Tobias Friebel		 |
 * +-----------------------------------------+
 * | Authors: Tobias Friebel <TobyF@Web.de>  |
 * +-----------------------------------------+
 *
 * Project: UserLoginSecurity
 *
 * $Id: UserGuthabenPostListener.class.php 133 2007-10-09 21:21:35Z toby $
 */

require_once(WCF_DIR.'lib/system/event/EventListener.class.php');

class UserLoginSecurityListener implements EventListener
{
	public static $user;

	/**
	 * @see EventListener::execute()
	 */
	public function execute($eventObj, $className, $eventName)
	{
		switch ($eventName)
		{
			case 'readParameters':
				$this->readParameters($eventObj);
			break;

			case 'validate':
				$this->validate($eventObj);
			break;

			case 'save':
				$editor = self :: $user->getEditor();
				$editor->updateOptions(array('failedLogins' => 0));
			break;
		}
	}

	/**
	 * remember failed logins...
	 */
	public function rememberFailedLogins($eventObj)
	{
		$sql = "INSERT INTO wcf".WCF_N."_user_failed_logins (failDate, username, userID, ipAddress, userAgent) ";
		$sql .= "VALUES ('".TIME_NOW."', '".escapeString($eventObj->username)."', '".intval(self :: $user->userID)."', " .
				"'".escapeString($_SERVER['REMOTE_ADDR'])."', '".escapeString($_SERVER['HTTP_USER_AGENT'])."')";
		WCF::getDB()->sendQuery($sql);

		if (self :: $user->userID != 0)
		{
			$editor = self :: $user->getEditor();
			$editor->updateOptions(array('failedLogins' => $editor->failedLogins + 1,
										 'lastFailedLogin' => TIME_NOW));
		}
	}

	/**
	 * activate captcha if neccessary
	 */
	public function readParameters($eventObj)
	{
		if (USER_SECURITY_CAPTCHA_GLOBAL_ACTIVATE_EVENTS > 0 && $eventObj->useCaptcha == false)
		{
			$sql = "SELECT COUNT(*) AS count FROM wcf".WCF_N."_user_failed_logins " .
					 "WHERE failDate > ".(TIME_NOW - USER_SECURITY_CAPTCHA_ACTIVATE_SECONDS);
			$count = WCF::getDB()->getFirstRow($sql);

			if ($count['count'] > USER_SECURITY_CAPTCHA_GLOBAL_ACTIVATE_EVENTS)
				$eventObj->useCaptcha = true;
		}

		if (USER_SECURITY_CAPTCHA_ACTIVATE_EVENTS > 0 && $eventObj->useCaptcha == false)
		{
			$sql = "SELECT COUNT(*) AS count FROM wcf".WCF_N."_user_failed_logins " .
					 "WHERE ipAddress LIKE '".escapeString($_SERVER['REMOTE_ADDR'])."' AND failDate > ".(TIME_NOW - USER_SECURITY_CAPTCHA_ACTIVATE_SECONDS);
			$count = WCF::getDB()->getFirstRow($sql);

			if ($count['count']  > USER_SECURITY_CAPTCHA_ACTIVATE_EVENTS)
				$eventObj->useCaptcha = true;
		}
	}

	/**
	 * override LoginForm Validate
	 */
	public function validate($eventObj)
	{
		self :: $user = new User(null, null, $eventObj->username);
		if (self :: $user->userID == 0)
		{
			$this->rememberFailedLogins($eventObj);
			throw new UserInputException('username', 'security');
		}

		// check password
		if (!self :: $user->checkPassword($eventObj->password))
		{
			$this->rememberFailedLogins($eventObj);
			throw new UserInputException('username', 'security');
		}

		if (USER_SECURITY_FAILED_LOGINS != 0 && self :: $user->failedLogins > USER_SECURITY_FAILED_LOGINS && TIME_NOW < self :: $user->lastFailedLogin + USER_SECURITY_FAILED_DELAY)
		{
			$this->rememberFailedLogins($eventObj);
			throw new UserInputException('username', 'security');
		}
	}
}
?>